.\" Automatically generated from an mdoc input file.  Do not edit.
.\" zip_register_progress_callback_with_state.mdoc -- provide updates during zip_close
.\" Copyright (C) 2017 Dieter Baron and Thomas Klausner
.\"
.\" This file is part of libzip, a library to manipulate ZIP archives.
.\" The authors can be contacted at <libzip@nih.at>
.\"
.\" Redistribution and use in source and binary forms, with or without
.\" modification, are permitted provided that the following conditions
.\" are met:
.\" 1. Redistributions of source code must retain the above copyright
.\"    notice, this list of conditions and the following disclaimer.
.\" 2. Redistributions in binary form must reproduce the above copyright
.\"    notice, this list of conditions and the following disclaimer in
.\"    the documentation and/or other materials provided with the
.\"    distribution.
.\" 3. The names of the authors may not be used to endorse or promote
.\"    products derived from this software without specific prior
.\"    written permission.
.\"
.\" THIS SOFTWARE IS PROVIDED BY THE AUTHORS ``AS IS'' AND ANY EXPRESS
.\" OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE IMPLIED
.\" WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
.\" ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHORS BE LIABLE FOR ANY
.\" DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
.\" DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE
.\" GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS
.\" INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER
.\" IN CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR
.\" OTHERWISE) ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN
.\" IF ADVISED OF THE POSSIBILITY OF SUCH DAMAGE.
.\"
.TH "ZIP_REGISTER_PROGRESS_CALLBACK_WITH_STATE" "3" "December 18, 2017" "NiH" "Library Functions Manual"
.nh
.if n .ad l
.SH "NAME"
\fBzip_register_progress_callback_with_state\fR
\- provide updates during zip_close
.SH "LIBRARY"
libzip (-lzip)
.SH "SYNOPSIS"
\fB#include <zip.h>\fR
.sp
\fItypedef void (*zip_progress_callback)(zip_t *, double, void *);\fR
.sp
\fIvoid\fR
.br
.PD 0
.HP 4n
\fBzip_register_progress_callback_with_state\fR(\fIzip_t\ *archive\fR, \fIdouble\ precision\fR, \fIzip_progress_callback\ callback\fR, \fIvoid\ (*ud_free)(void\ *)\fR, \fIvoid\ *ud\fR);
.PD
.SH "DESCRIPTION"
The
\fBzip_register_progress_callback_with_state\fR()
function registers a callback function
\fIcallback\fR
for the zip archive
\fIarchive\fR.
The
\fIprecision\fR
argument is a double in the range from 0.00 to 1.0 that defines the
smallest change for which the callback should be called (to avoid too
frequent calls).
The
\fIud_free\fR
function is called during cleanup for deleting the userdata supplied in
\fIud\fR.
.PP
The callback function is called during
zip_close(3)
in regular intervals (after every zip archive entry that's completely
written to disk, and while writing data for entries) with zip archive
\fIarchive\fR,
the current progression state as a
\fIdouble\fR,
and the user-provided user-data
\fIud\fR
as arguments.
The progression state is a
\fIdouble\fR
in the range from 0.0 to 1.0.
This can be used to provide progress indicators for user interfaces.
.SH "SEE ALSO"
libzip(3),
zip_close(3)
.SH "HISTORY"
\fBzip_register_progress_callback_with_state\fR()
was added in libzip 1.3.0.
.SH "AUTHORS"
Dieter Baron <\fIdillo@nih.at\fR>
and
Thomas Klausner <\fItk@giga.or.at\fR>
