## Presentation:
- First demonstrated in November 1998 at JAMMA, since just before the release of The House of the Dead 2 in Japan. 
- The Sega Naomi (New Arcade Operation Machine Idea) is the successor to the Sega Model 3 hardware.

### A development of the Dreamcast home game console, the NAOMI and Dreamcast share the same hardware components: 
- Hitachi SH-4 CPU, 
- PowerVR Series 2 GPU (PVR2DC), and 
- Yamaha AICA based sound system.   

NAOMI has twice as much system memory, twice as much video memory, and 4X as much sound memory. 
Multiple NAOMI boards can be 'stacked' together to improve graphics performance, or to support multiple-monitor output. 
A special game cabinet for the NAOMI, **NAOMI Universal Cabinet**, houses up to sixteen boards for this purpose.

_The other key difference between NAOMI and Dreamcast lies in the game media._

The Dreamcast reads game data from GD-ROM optical disc, while the NAOMI arcade board features 168 MB of solid-state ROMs or GD-ROMs using a custom DIMM board and GD-ROM drive. 

- In operation, the Naomi GD-ROM is read only once at system power up, loading the disc's contents to the DIMM Board RAM. 
Once loading is complete, the game executes only from RAM, thereby reducing mechanical wear on the GD-ROM drive.
Unlike Sega's previous arcade platforms (and most other arcade platforms in the industry), 

NAOMI is widely licensed for use by other game publishers including Sega, Namco Bandai, Capcom, Sammy and Tecmo Koei. 
Games such as Mazan, Marvel Vs. Capcom 2, Dead or Alive 2 and Guilty Gear XX were all developed by third-party licensees of the NAOMI platform. 

**An offshoot version of the NAOMI hardware is Atomiswave by Sammy Corporation.**

After nine years of hardware production, and with new game titles coming in 2008 like Melty Blood: Actress Again and Akatsuki Blitzkampf AC, 
NAOMI is considered to be one of the longest running arcade platforms ever and is comparable in longevity with the Neo-Geo MVS.


## Technical Specification:

- Main Processor : Hitachi SH-4 (128 bits) RISC 360 MIPS / 1.4 GFLOPS clocked 200 MHz
- Video Processor : PowerVR 2 clocked 100 MHz made by Nec (Nec CLX2)
    - Texture mapping
    - Trilinear filtering
    - Micro texturing
    - Specular reflection
    - Gouraud shading
    - Flat shading
    - Anti-aliasing
    - Alpha blending
- Audio Processor : ARM7 Yamaha XG AICA RISC 32 bits clocked 25 MHz
